#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <sys/time.h>
#include <math.h>
#include "clock.C"
#include <plinda.h>
#include "size.h"

#ifdef  __GNUC__
#include <builtin.h>

extern "C" {
   double drand48();
   void srand48(long);
}
#endif

long	seed = 0;
int	checkResult = 0;
int	outputResult = 0;

typedef	float Matrix[size][size];


void randomFill(Matrix m) {
   for (int i=0; i<size; i++)
     for (int j=0; j<size; j++)
       m[i][j] = (float)(drand48() - 0.5) * 1000.;
}

void print(Matrix m, int size) {
   cout.setf(ios::scientific, ios::floatfield);
   for (int i=0; i<size; i++) {
      for (int j=0; j<size; j++)
	cout << m[i][j] << "\t";
      cout << endl;
   }
}

const bool iszero(const float x)
{
   return x == 0.0;
}

int isclose(double x) {
  if(x < 0)
    x = -x;
  if(x < 1e-5) 
    return 1;
  else {
    cout << x << "is not zero!!!\n" << flush;
    return 0;
  }
}


int matrixEq(Matrix A, Matrix B, int rows, int cols) {
  int rounderCaught = 0;
   for (int i=0; i<rows; i++)
     for (int j=0; j<cols; j++) {
       if (!iszero(A[i][j] - B[i][j])) {
	 if(isclose(A[i][j] - B[i][j])) {
	   if(!rounderCaught) {
	     cout << "at least two elements of the matrices are off, but they"
		  << " are close so I won't consider this a failure\n";
	     rounderCaught = 1;
	   }
	 } else
	   return 0;
       }
       return 1;
     }
}
void transpose(Matrix A, int size) {
   float		temp;
   for (int i=0; i<size; i++)
     for (int j=i+1; j<size; j++) {
	temp = A[i][j];
	A[i][j] = A[j][i];
	A[j][i] = temp;
     }
}

void mm(Matrix A, Matrix B, Matrix C)
{
   for (int i=0; i<size; i++) {
      for (int j=0; j<size; j++) {
	 C[i][j] = (float)0.;
	 for (int k=0; k<size; k++)
	   C[i][j] += (A[i][k] * B[j][k]); 
      }
   }
}
Matrix A, B, C;
Matrix D;


int real_main(int argc, char *argv[],char **env) 
{

  int NumSlaves = 2, tranNumber = 0 ;
  assert(size % Grain == 0);
  gid ts_handle;

#ifndef NDEBUG
   checkResult = 1;
#endif
   srand48(seed);
   randomFill(A);
   randomFill(B);
   if((_PLtemp = Tuple::create(3,0 ), _PLtemp->setFormal(0, TupleField::PLint,(int*)(&(tranNumber))), _PLtemp->setFormal(1, TupleField::PLgid,(gid*)(&(ts_handle))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(NumSlaves))), xrecover(_PLtemp)) )
     
     {
       cout << "Master recovering from transaction " << tranNumber << endl;
       cout << "with " << NumSlaves << " slaves\n" << flush;
     } else {
       do {
	 cout << "enter number of slaves \n" << flush;
	 cin >> NumSlaves ;
       } while(NumSlaves < 0) ;
       char c;
       cin.get(c);
     }
   if(tranNumber == 0) { 
      xstart; 
      ts_handle = create_group("mailbox");
      for(int i = 0 ; i < NumSlaves ; i++) 
	(_PLtemp = Tuple::create(2,0 + ((::strlen("matrix.slave.float")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"matrix.slave.float",(::strlen("matrix.slave.float") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLgid,(const gid)ts_handle), pl_proc_eval(_PLtemp)) ;
      tranNumber++;
      (_PLtemp = Tuple::create(3,0 ), _PLtemp->setActual(0, TupleField::PLint,(const int)tranNumber), _PLtemp->setActual(1, TupleField::PLgid,(const gid)ts_handle), _PLtemp->setActual(2, TupleField::PLint,(const int)NumSlaves), xcommit(_PLtemp)) ;
	
   } 
  cout << "Press return to start" << ::flush;
   char		c;
   cin.get(c);

   start("mult...");
   transpose(B, size);
   if(tranNumber == 1) {
      
      xstart; 
      (_PLtemp = Tuple::create(2,0 + ((::strlen( "this is b!!!!\n")+1) * sizeof(char)) + sizeof(float) *( size*size) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*) "this is b!!!!\n",(::strlen( "this is b!!!!\n") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLfloat,(const float*)B[0],size*size), pl_out(ts_handle, _PLtemp)) ;
      for(int i = 0; i < size ; i+= Grain)  
	(_PLtemp = Tuple::create(2,0 + sizeof(float) *( Grain*size) ), _PLtemp->setActual(0, TupleField::PLint,(const int)i), _PLtemp->setActual(1, TupleField::PLfloat,(const float*)A[i],Grain*size), pl_out(ts_handle, _PLtemp)) ;
      tranNumber++;
      (_PLtemp = Tuple::create(3,0 ), _PLtemp->setActual(0, TupleField::PLint,(const int)tranNumber), _PLtemp->setActual(1, TupleField::PLgid,(const gid)ts_handle), _PLtemp->setActual(2, TupleField::PLint,(const int)NumSlaves), xcommit(_PLtemp)) ;
      
   }
   if(tranNumber == 2) {
      
      xstart;
      for(int i = 0 ; i < size ; i += Grain)  {
	(_PLtemp = Tuple::create(3,0 + ((::strlen("res")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"res",(::strlen("res") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)i), _PLtemp->setFormal(2, TupleField::PLfloat,(float*)(C[i]),Grain*size), pl_in(ts_handle, _PLtemp)) ;

	}	
      tranNumber++;
      (_PLtemp = Tuple::create(3,0 ), _PLtemp->setActual(0, TupleField::PLint,(const int)tranNumber), _PLtemp->setActual(1, TupleField::PLgid,(const gid)ts_handle), _PLtemp->setActual(2, TupleField::PLint,(const int)NumSlaves), xcommit(_PLtemp)) ;
      
   }

   done();

   if(tranNumber == 3) {
      
      xstart;
      
      (_PLtemp = Tuple::create(2,0 + ((::strlen( "this is b!!!!\n")+1) * sizeof(char)) + sizeof(float) *( size*size) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*) "this is b!!!!\n",(::strlen( "this is b!!!!\n") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLfloat,(const float*)B[0],size*size), pl_in(ts_handle, _PLtemp)) ;
      for(int i = 0 ; i < NumSlaves ; i++)  
	(_PLtemp = Tuple::create(2,0 + sizeof(float) *( 1) ), _PLtemp->setActual(0, TupleField::PLint,(const int)-1), _PLtemp->setActual(1, TupleField::PLfloat,(const float*)A[0],1), pl_out(ts_handle, _PLtemp)) ;
      tranNumber++;
      (_PLtemp = Tuple::create(3,0 ), _PLtemp->setActual(0, TupleField::PLint,(const int)tranNumber), _PLtemp->setActual(1, TupleField::PLgid,(const gid)ts_handle), _PLtemp->setActual(2, TupleField::PLint,(const int)NumSlaves), xcommit(_PLtemp)) ;
      
   }
#ifndef NDEBUG
   if (checkResult) {
      cout << "Checking the results..." << flush;
      mm(A, B, D);
      if (matrixEq(C, D, size, size))
	cout << "succeeded." << endl << flush;
      else
	cout << "failed." << endl << flush;
   }

   if (outputResult) {
      cout << "Matrix A:" << endl;
      print(A, size);
      cout << "Matrix B:" << endl;
      print(B, size);
      cout << "Matrix AXB:" << endl;
      print(C, size);
   }
#endif
}



