
#ifndef _SL_FN_H_
#define _SL_FN_H_

extern void print_expn(s_complex* e);
extern void leaf_level_expns(int start_row, int grain_size, int *num_particles,
			     s_particle **particles,s_complex ***phi_val);
extern void push_phi_values(int act_level,int act_row,int num_rows,int subtree_depth,
			    s_complex ***phi_val);
extern void compute_ilist_values(int row,int level,int num_rows, 
				 s_complex ***phi_val,s_complex ***ilist_val);
extern int in_interaction(int i,int j,int p,int k,int level,int row);
extern void add_local_expansion(int level,int row,int i,int j,int p,int k,int depth,
				s_complex ***phi_val,s_complex ***ilist_val);
extern void shift_phi(s_complex* this_row,s_complex* parent_row,s_complex by_z);
extern void compute_multipole_expn(int level,int row,int offset,int box_no,
				   int  start_particle,int end_particle,
				   s_particle **particles,s_complex  ***phi_val, 
				   int depth);
extern void shift_local(s_complex by_z,s_complex *old_coeff,s_complex *new_coeff);
extern float total_charge(s_particle *lp,int n);
extern void init_comb_table();
extern s_complex get_center(int lev,int i,int j);
extern s_complex potential(int rowi,int pi,int rowj,int pj,s_particle **particles);
extern s_complex eval_psi(s_complex* psi,s_complex z);
extern void compute_internal_fld(int offset,int  p_start,int  p_end,
				 s_particle** particles);
extern void compute_psi(s_complex ***psi_val,s_complex ***ilist_val,
			s_complex ***psi_bar_val,
			int level,int lev_offset);
extern void compute_psi_bar(s_complex ***psi_bar_val,s_complex ***psi_val,
			    int start_row,int level,int i,int grain_size);
extern void compute_row_far_field(int row,int i,s_particle** particles,int *num_particles,
				  s_complex***psi_val, int j);
extern void compute_row_near_field(int row,int i,s_particle **particles,
				   int *num_particles, int grain_size);
extern void print_particles(s_particle** particles,int* num_particles,int  grain_size);

#endif  /* _SL_FN_H_ */
