
#include <stream.h>
#include <malloc.h>
#include <plinda.h>

#include "ds.h"
#include "global.h"
#include "plinda_fns.h"

int real_main(int argc,char **argv, char**env)
{
    int my_id, grain_size, i;
    gid g;
    int  val , pass, start_row, level, *num_particles;
    s_complex  ***phi_val, ***psi_val, ***ilist_val, ***psi_bar_val;
    s_particle  **particles;
    extern void init_comb_table();
    int num_jobs_done = 0;
    int next_trans = 0;


    if (recover_worker_state(pass, start_row, level, my_id, val,
		      grain_size, g,next_trans, num_jobs_done)) {
	cout << "worker " << my_id << " recovered from failure.\n" << flush;
	cout << "...and cont. from transaction = " << next_trans << " \n" << flush;
    }


    
    if (next_trans==0){
	xstart;
	if(!argument_rdp_params(my_id, grain_size, g)) {
	  cerr << "slave " << my_id << " failed to read its argument.\n" << flush;
	}
	out_slave_started(my_id,g); 
	next_trans++;

	(_PLtemp = Tuple::create(10,0 + ((::strlen("slave_state")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_state",(::strlen("slave_state") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)pass), _PLtemp->setActual(2, TupleField::PLint,(const int)start_row), _PLtemp->setActual(3, TupleField::PLint,(const int)level), _PLtemp->setActual(4, TupleField::PLint,(const int)my_id), _PLtemp->setActual(5, TupleField::PLint,(const int)val), _PLtemp->setActual(6, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(7, TupleField::PLgid,(const gid)g), _PLtemp->setActual(8, TupleField::PLint,(const int)next_trans), _PLtemp->setActual(9, TupleField::PLint,(const int)num_jobs_done), xcommit(_PLtemp)) ;



    }
    

    if (next_trans==1){
	xstart;
	i = -1;
	rd_slave_started(i,g);
	next_trans++;

	(_PLtemp = Tuple::create(10,0 + ((::strlen("slave_state")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_state",(::strlen("slave_state") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)pass), _PLtemp->setActual(2, TupleField::PLint,(const int)start_row), _PLtemp->setActual(3, TupleField::PLint,(const int)level), _PLtemp->setActual(4, TupleField::PLint,(const int)my_id), _PLtemp->setActual(5, TupleField::PLint,(const int)val), _PLtemp->setActual(6, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(7, TupleField::PLgid,(const gid)g), _PLtemp->setActual(8, TupleField::PLint,(const int)next_trans), _PLtemp->setActual(9, TupleField::PLint,(const int)num_jobs_done), xcommit(_PLtemp)) ;




    }
    


    alloc_memory(grain_size, &phi_val, &psi_val, &psi_bar_val, 
		 &ilist_val, &num_particles, &particles);
    init_comb_table();




    while(1) {
	
	
	if (next_trans==2){
	    xstart;
	    
	    val = get_job(&pass, &start_row, &level, grain_size, g);
	    if (val==0) next_trans = 2;
	    else if (val==-1)	next_trans = 4;
	    else {
		next_trans++;
		cout << "slave  " << my_id << "  processing job : <" << 
		    pass << " " << level << " " << start_row << ">\n" << flush;
	    }
	(_PLtemp = Tuple::create(10,0 + ((::strlen("slave_state")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_state",(::strlen("slave_state") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)pass), _PLtemp->setActual(2, TupleField::PLint,(const int)start_row), _PLtemp->setActual(3, TupleField::PLint,(const int)level), _PLtemp->setActual(4, TupleField::PLint,(const int)my_id), _PLtemp->setActual(5, TupleField::PLint,(const int)val), _PLtemp->setActual(6, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(7, TupleField::PLgid,(const gid)g), _PLtemp->setActual(8, TupleField::PLint,(const int)next_trans), _PLtemp->setActual(9, TupleField::PLint,(const int)num_jobs_done), xcommit(_PLtemp)) ;



	 }
	if (next_trans==4) break;
	

	if (next_trans==3){
	    xstart;
	    get_data(pass, start_row, level, grain_size,
		     particles, num_particles, phi_val, psi_val, 
		     psi_bar_val, ilist_val, g);

	    compute(pass, start_row, level, grain_size,
		    particles, num_particles, phi_val, psi_val, 
		    psi_bar_val, ilist_val); 
	    
	    
	    output_results(pass, start_row, level, grain_size,
			   particles, num_particles, phi_val, psi_val, 
			   psi_bar_val, ilist_val, g); 
	    
	    num_jobs_done++;
	    next_trans = 2;

	(_PLtemp = Tuple::create(10,0 + ((::strlen("slave_state")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_state",(::strlen("slave_state") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)pass), _PLtemp->setActual(2, TupleField::PLint,(const int)start_row), _PLtemp->setActual(3, TupleField::PLint,(const int)level), _PLtemp->setActual(4, TupleField::PLint,(const int)my_id), _PLtemp->setActual(5, TupleField::PLint,(const int)val), _PLtemp->setActual(6, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(7, TupleField::PLgid,(const gid)g), _PLtemp->setActual(8, TupleField::PLint,(const int)next_trans), _PLtemp->setActual(9, TupleField::PLint,(const int)num_jobs_done), xcommit(_PLtemp)) ;



	}
}
    
    
    if (next_trans==4){
	xstart;
	out_slavedone(my_id, num_jobs_done, g);
	next_trans = 5;

	(_PLtemp = Tuple::create(10,0 + ((::strlen("slave_state")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_state",(::strlen("slave_state") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)pass), _PLtemp->setActual(2, TupleField::PLint,(const int)start_row), _PLtemp->setActual(3, TupleField::PLint,(const int)level), _PLtemp->setActual(4, TupleField::PLint,(const int)my_id), _PLtemp->setActual(5, TupleField::PLint,(const int)val), _PLtemp->setActual(6, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(7, TupleField::PLgid,(const gid)g), _PLtemp->setActual(8, TupleField::PLint,(const int)next_trans), _PLtemp->setActual(9, TupleField::PLint,(const int)num_jobs_done), xcommit(_PLtemp)) ;



    }
    

}










