
#ifndef _DS_H_
#define _DS_H_ 

#include <math.h>
#include <plinda.h>
#include <timing.h>

#include "param.h"
 
/*----------------------------------------------------------------*/

typedef struct scomplx {
    float rl, im;
} s_complex, *p_complex;

typedef struct ipair {
    int  s,e;
} s_intpair, *p_intpair;


typedef struct sparticle {
    s_complex  z;
    float      q;
    s_complex  f;
    int        n;  /*box num in the row*/
}  s_particle, *p_particle;

/*----------------------------------------------------------------*/

extern int         two_k[11];
extern int         dim[11] ;
extern int	    fact[11];
extern int         n_choos_k[2*PRECISION+1][2*PRECISION+1];
extern s_complex   NIL_COMPLEX;
extern s_particle  NIL_PARTICLE;
extern int         Log2[33];
/*----------------------------------------------------------------*/


extern int read_input(char* pfile);
extern void add_tuples(int grain_size, gid g);
extern void out_results(gid g);
extern int get_job(int *pass,int *start_row,int *level,int grain_size, gid g);
extern int get_data(int pass,int start_row,int level,int grain_size,
		    s_particle **particles,int *num_particles, 
		    s_complex ***phi_val,s_complex ***psi_val, 
		    s_complex ***psi_bar_val,s_complex ***ilist_val, gid g);
extern int compute(int pass,int start_row,int level,int grain_size,
		   s_particle **particles,int *num_particles, 
		   s_complex ***phi_val,s_complex ***psi_val, 
		   s_complex ***psi_bar_val,s_complex ***ilist_val);
extern int output_results(int pass,int start_row,int level,int grain_size,
			  s_particle **particles,int *num_particles, 
			  s_complex ***phi_val,s_complex ***psi_val, 
			  s_complex ***psi_bar_val,s_complex ***ilist_val, gid g);
extern void alloc_memory(int grain_size, s_complex ****phi_val, s_complex ****psi_val, 
			 s_complex ****psi_bar_val, s_complex ****ilist_val,
			 int **num_particles,s_particle ***particles);
extern void init_comb_table();

#endif  /* _DS_H_ */
