
#include <stream.h>
#include <stdio.h>
#include <stdlib.h>
#include "ds.h"
#include "plinda_fns.h"
#include <plinda.h>
extern "C" {
FILE* fopen(const char*, const char*);
}

/*-----------------------------------------------------------------------*/

s_particle     **global_particles = NULL;
int	       *global_num_particles = NULL;

/*-----------------------------------------------------------------------*/
void 
init_comb_table(){
    int i,j;
    for(i=0;i<2*PRECISION;i++){
	for(j=0; j<=i; j++){
	    n_choos_k[i][j] = fact[i]/(fact[j]*fact[i-j]);
	    if (j<i) n_choos_k[j][i] = 0;
	}
    }
}

/*--------------------------------------------------------------------------*/

int
read_input(char* pfile)
{
    FILE *fin;
    int  i,j,t,prev_i, n=0;
    float  x,y,q;
    
    
    /* alloc memory to store the read in particle data from file */
    global_num_particles = (int*)calloc(dim[LeafLevel],sizeof(int));
    global_particles = (s_particle**)calloc(dim[LeafLevel],4);
    for(i=0; i<dim[LeafLevel]; i++){
	global_particles[i] = 
	    (s_particle*)calloc(MaxNumRowPar, sizeof(s_particle));
    }

    /* init the allocated memory */
    for(i=0; i<dim[LeafLevel]; i++){
	for(j=0; j<MaxNumRowPar; j++) 
	    global_particles[i][j] = NIL_PARTICLE;
	global_num_particles[i] = 0;
    }
    
    i=prev_i=j=0;
    x = y = q = 0.0;
    fin = fopen(pfile, "r");
    if(fin == NULL) {
       cerr << "Cannot open the file " << pfile << " please put particle data there.\n";
       cerr << "You can find particle data in the source file directory file particle.data\n";
       cerr << "Or use the program gen in the source directory to create a data file.\n";
       cerr << "fatal error...\n" << flush;
       return 0;
    }
    while(fscanf(fin, "%d %d %f %f %f", &i,&j,&x,&y,&q) != EOF){
	/* fscanf(fin, "%d %d %f %f %f", &i,&j,&x,&y,&q); */
	if (i==prev_i)
	    global_num_particles[i]++;
	else {
	    prev_i = i;
	    global_num_particles[i]++;
	}
	t =  global_num_particles[i] -  1;
	global_particles[i][t].z.rl = x;
	global_particles[i][t].z.im = y;
	global_particles[i][t].f = NIL_COMPLEX;
	global_particles[i][t].q = q;
	global_particles[i][t].n = j;
	n++;
    }
    
    fclose(fin);
    cout << "num particles = " << n << "\n" << flush;
    cout << "initializing data structures...\n" << flush;
    init_comb_table();
    return 1;
}
/*-------------------------------------------------------------------------------------*/
void 
add_tuples(int grain_size, gid g)
{
    int  i, j;
    
    assert(global_num_particles);
    assert(global_particles);
    for(i=0; i<dim[LeafLevel]; i++){
	out_particles(i,global_num_particles[i],global_particles[i], g);
    }
    for(i=0, j=0; i<dim[LeafLevel]; i += grain_size, j++){
	out_job(LeafLevel, i, g);
    }
    /* ("job_counter", pass, level, num_done, num_todo) */
    out_counter(UpwardPass, LeafLevel, 0, j, g);
    /* upward pass initialized */
}
/*-------------------------------------------------------------------------------------*/
void 
out_results(gid g)
{
    FILE *f, *fopen();  int i,j;
    
    /*

    for(i=0; i<dim[LeafLevel]; i++) 
	in_particles(i, global_num_particles[i], global_particles[i], g);
    
   
    f = fopen("Results", "w");
    for(i=0; i<dim[LeafLevel]; i++){
	for(j=0; j<global_num_particles[i]; j++){
	    fprintf(f,"%f %f %f %f\n", 
		    global_particles[i][j].z.rl,
		    global_particles[i][j].z.im,
		    global_particles[i][j].q,	
		    global_particles[i][j].f.rl);
	}
    }
    fclose(f); 
    cout << "output is in file = \"Results\"\n" << flush; 

    */

}
/*-------------------------------------------------------------------------------------*/
