

#include <stream.h>
#include <stdio.h>
#include <stdlib.h>
#include "timing.h"
#include "ds.h"

#include <plinda.h>
#include "global.h"
#include "plinda_fns.h"


int real_main(int argc,char **argv, char** env)
{

    int  i, num_workers, n, grain_size, 
         next_trans = 0, num_done=0;
    gid  g;
    char pfile[60];
    
    if (recover_master_state(g, grain_size, num_workers, pfile,next_trans)) { 
	cout << "master process recovers from failure.\n" 
	    << " ...and cont. from transaction : "
	    << next_trans << " \n"  << flush;
    }


    if (next_trans==0){
	xstart;
	cout << "number of workers = ";
	cin >> num_workers;
	system("pwd");
	::strcpy(pfile, "data/particle.data");
	cout << "reading particle data from file = ~/" << pfile << ". \n\n" 
	  << flush;
	if(!read_input(pfile))
	  return 1; 

	grain_size = 4;

	g = create_group("tuples_grp");

	add_tuples(grain_size,g);

	for(i=0; i<num_workers; i++){
	   
	   (_PLtemp = Tuple::create(4,0 + ((::strlen("wparticle")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"wparticle",(::strlen("wparticle") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)i), _PLtemp->setActual(2, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(3, TupleField::PLgid,(const gid)g), pl_proc_eval(_PLtemp)) ;

	}
	next_trans++;

	(_PLtemp = Tuple::create(5,0 + (::strlen(pfile) +1)* sizeof(char) ), _PLtemp->setActual(0, TupleField::PLgid,(const gid)g), _PLtemp->setActual(1, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(2, TupleField::PLint,(const int)num_workers), _PLtemp->setActual(3, TupleField::PLchar,(const char*)pfile,::strlen(pfile)+1), _PLtemp->setActual(4, TupleField::PLint,(const int)next_trans), xcommit(_PLtemp)) ;


     }
    cout << "input added to tuple space. \n" << flush;    
    

    if (next_trans==1){
	xstart;

	for(i=0; i<num_workers; i++){
	    in_slave_started(i, g);
	}
	i = -1;
	out_slave_started(i,g);

	next_trans++;
	(_PLtemp = Tuple::create(5,0 + (::strlen(pfile) +1)* sizeof(char) ), _PLtemp->setActual(0, TupleField::PLgid,(const gid)g), _PLtemp->setActual(1, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(2, TupleField::PLint,(const int)num_workers), _PLtemp->setActual(3, TupleField::PLchar,(const char*)pfile,::strlen(pfile)+1), _PLtemp->setActual(4, TupleField::PLint,(const int)next_trans), xcommit(_PLtemp)) ;

	cout << "created " << num_workers <<" workers. \n" << flush;
    }


    
    BEGINTIMING;   
    

    if (next_trans==2){
	xstart;

	for(i=0; i<num_workers; i++){
	    in_slavedone(n, num_done, g);
	    cout << "worker " << n << " finished processing. num jobs done = " 
		<< num_done << " \n"; 
	}

    
    ENDTIMING;    
    

	out_results(g);

	next_trans++;
	(_PLtemp = Tuple::create(5,0 + (::strlen(pfile) +1)* sizeof(char) ), _PLtemp->setActual(0, TupleField::PLgid,(const gid)g), _PLtemp->setActual(1, TupleField::PLint,(const int)grain_size), _PLtemp->setActual(2, TupleField::PLint,(const int)num_workers), _PLtemp->setActual(3, TupleField::PLchar,(const char*)pfile,::strlen(pfile)+1), _PLtemp->setActual(4, TupleField::PLint,(const int)next_trans), xcommit(_PLtemp)) ;


    }
    

    cout << "computation finished. \n";
    cout << "total computation time approximately:: \n\n" << flush;
    cout << "seconds: " << TIMINGS << "    milliseconds: " <<  TIMINGMS 
	<< " \n" << flush ; 
    
}
