/******************************* 
File:		Char_Match.c 
Last Revision:	11/3/95
Purpose:	Case-Insensitive matching
*******************************/
#include "Char_Match.h"

#define MAX_LEN_KEY 15
#define UNDERSCORE 95


/******
Function:	Number
Purpose:	Return 1 if the character passed in is a number (0-9)
******/
int
Number(char a)
{
	if ((a >= ASCII_INT_LOWER) && (a <= ASCII_INT_UPPER))
		return 1;
	return 0;
}


/******
Function:	Get_Number
Purpose:	Return 1 if the character passed in is a number (0-9)
******/
int
Get_Number(char a)
{
	return (a - ASCII_INT_LOWER); 
}



/******
Function:	Alpha
Purpose:	Return 1 if the character passed in is a letter.
******/
int
Alpha(char a)
{
	if ((a >= LOWER_CASE_LOW_BOUND) && (a <= LOWER_CASE_UP_BOUND))
		return 1;
	if ((a >= UPPER_CASE_LOW_BOUND) && (a <= UPPER_CASE_UP_BOUND))
		return 1;
	if (a == UNDERSCORE)
		return 1;
	return 0;
}



/******
Function:	Lower_Case_Letter
Purpose:	Return 1 if the character passed in is a lower case letter.
******/
int
Lower_Case_Letter(char a)
{
	if ((a >= LOWER_CASE_LOW_BOUND) && (a <= LOWER_CASE_UP_BOUND))
		return 1;
	return 0;
}



/******
Function:	Upper_Case_Letter
Purpose:	Return 1 if the character passed in is a upper case letter.
******/
int
Upper_Case_Letter(char a)
{
	if ((a >= UPPER_CASE_LOW_BOUND) && (a <= UPPER_CASE_UP_BOUND))
		return 1;
	return 0;
}




/******
Function:	char_test
Purpose:	See if two characters Match using a case-insensitive
		rule. 
******/
int
char_test(char key, char comp)
{
  	int case_conv = LOWER_CASE_LOW_BOUND - UPPER_CASE_LOW_BOUND ;

	if (key == comp)
		return 1;
	if (key == '\0')
		return 1;
	if ((comp >= UPPER_CASE_LOW_BOUND) && (comp <= UPPER_CASE_UP_BOUND))
 		if (key == (comp + case_conv))
			return 1;
		else
			return 0;
     	if ((comp >= LOWER_CASE_LOW_BOUND) && (comp <= LOWER_CASE_UP_BOUND))
		if (key == (comp - case_conv))
			return 1;
		else
			return 0;
     	if ((comp < UPPER_CASE_LOW_BOUND) || (comp > LOWER_CASE_UP_BOUND))
		if (key != comp)
			return 0;	
	return 1;
}



int
keyword_test(char key[MAX_LEN_KEY], char comp[MAX_LEN_KEY], int len)
{
  int i;
  int offset;	
  int case_conv = LOWER_CASE_LOW_BOUND - UPPER_CASE_LOW_BOUND ;
/***
 fprintf(stderr,"\n\n\tkeyword_test:: test:: %s vs. %s \n",key,comp);
 fprintf(stderr,"\tkeyword_test:: test =>  %d",len);
***/

  for (offset = 0, i=0; i < len; offset++,i++) 
  {
	if (key[i] == '\0')
		return 1;
	while ((comp[offset] == ' ') || (comp[offset] == '\t'))
	{
		offset++;
		if (offset == len) 
			return 0;
	}
/*****
 fprintf(stderr,"\tkey:: key =>  %d",key[i]);
 fprintf(stderr,"\tkey:: key =>  %c\n",key[i]);
 fprintf(stderr,"\tvs. \tkey:: comp => %d\n",comp[offset]);
 fprintf(stderr,"\tvs. \tkey:: comp => %c\n\n",comp[offset]);
****/
     if ((comp[offset] >= UPPER_CASE_LOW_BOUND) && (comp[offset] <= UPPER_CASE_UP_BOUND))
 	if ((key[i] == comp[offset]) || (key[i] == (comp[offset] + case_conv)))
		continue;
	else
		return 0;
     if ((comp[offset] >= LOWER_CASE_LOW_BOUND) && (comp[offset] <= LOWER_CASE_UP_BOUND))
	if ((key[i] == comp[offset]) || (key[i] == (comp[offset] - case_conv)))
		continue;
	else
		return 0;
     if ((comp[offset] < UPPER_CASE_LOW_BOUND) || (comp[offset] > LOWER_CASE_UP_BOUND))
	if (key[i] != comp[offset])
		return 0;	
  }
/**
  fprintf(stderr,"key_wordtest:: LEX_KEYWORD_TYPE  =>  \t%s\n",key);
**/
  return 1;
}
