/******************************* 
File:		DebugError.c
Last Revision:	11/9/95
Purpose:	This file is used expressly for debugging purposes;
		this is done via the ifdef/define of the DEBUG variable.
*******************************/
#include <stdio.h>
#include "DebugError.h"

#define DEBUG 1


/*****
Function:	Error
Purpose:	A method to check all pointers during debugging phase in a modular, 
		concise fashion
*****/
int
Error(void * Pointer, char * functionName, char * pointerName)
{
#ifdef  DEBUG
	if (Pointer==NULL)
	{
		fprintf(stderr,"Error:: %s NULL in %s",pointerName, functionName);
		return 1;
	}
#endif
	return 0;
}


/*****
Function:	Out
Purpose:	Output to stderr the char string passed in.
		A simple way to turn off all debugging output in the 
		program.
*****/
void
Out(char * str)
{
#ifdef  DEBUG
	fprintf(stderr,"%s",str);
#endif
}


/*****
Function:	Out_Int
Purpose:	Output to stderr the integer passed in.
		A simple way to turn off all debugging output in the 
		program.
*****/
void
Out_Int(int var)
{
#ifdef  DEBUG
	fprintf(stderr," %d ",var);
#endif
}



/*****
Function:	Out_Char
Purpose:	Output to stderr the char. passed in
		A simple way to turn off all debugging output in the 
		program.
*****/
void
Out_Char(char var)
{
#ifdef  DEBUG
	fprintf(stderr,"%c",var);
#endif
}

