/********	
File:	 	Decorate_Generate.c
Purpose: 	This file has the 2 phases of the PLinda/Fortran compiler
		1. Decorate
		2. Generate 
Last Altered:	2/1/96
********/
#include <stdio.h>
#include <stdlib.h>
#include "context.h"
#include "Match_keywords.h"
#include "Decorate_Generate.h"


#define DECORATE 1      /*  Comment out PLinda functions - Decorate phase. */
#define GENERATE 0      /*  Actively translate Fortran/PLinda.		*/
 
extern int line_number; 
char * File_Name;

char *
Strip_File_Name(char * file_name)
{
	char * out_file, * out_file2, * i_scan;
	out_file = (char *)malloc(sizeof(char)*80);
	i_scan = file_name;

	out_file2 = out_file;
	while (*i_scan != '.')
		*out_file++ = *i_scan++;
	*out_file++ = '.';
	*out_file++ = 'f';
	*out_file++ = '\0';
	return(out_file2);
}



/****
#define key_test(key,x) \
  if(!strcmp(key,temp)) { \
      printf("LEX_KEYWORD_TYPE %s\n",key); \
      return(1);\
    }
*****/
/* Not presently used - the above is a macro to test for keywords */



/******
Function:	Decorate
Purpose:	This function looks for all PLinda keywords, and puts a comment 
		on each line that contains them.  Then, the Fortran compiler is
		called to check the correctness of the syntax of the source code.
		If the Fortran code is incorrect, the function returns 0 to flex().
		If the Fortran is correct, the function returns 1 to flex().
******/
int
Decorate(CONTEXT * c, char * file_name)
{
	FILE * plinda;
	char comp_str[80];
	int status;

	File_Name = Strip_File_Name(file_name);
/**
fprintf(stderr,"Decorate:: file_name to write the decorated code to => %s\n",File_Name);
fflush(stderr);
**/
	if ((plinda=fopen(File_Name,"w"))==NULL)
        {
                fprintf(stderr,"*** ERROR can't open plinda.f file.\n");
                exit(1);
        }

/* 1. For each line in file fp lex/parse the buffer, echo to <plinda.f>
	the keywords in Fortran 77 language but not in the plinda. */
	line_number = 0;
        while(1)
        {
                lex_key_word(c, plinda, DECORATE);
                if (!CON_next_line(c))
                        break;
                line_number++;
		fflush(plinda);
        }
	fclose(plinda);

/***
Author:	Tom Brown
Date:	2/1/96
Why?	Some systems may have Fortran problems.  Suppressing the
	definition of FORTRAN_PARSE will produce the PLinda target
	regardless of the Fortran problems.
***/

#define FORTRAN_PARSE 1
#ifdef FORTRAN_PARSE
	sprintf(comp_str,"f77 -c %s",File_Name);
fprintf(stdout,"%s\n",comp_str);
fflush(stdout);
        status = system(comp_str);
        if (status > 0)
      		return (0);
	else
	{
        	status = system("rm -f a.out");
	}
#endif
	return 1;
}



/*****
Function:	Generate
Purpose:	This function translates the Fortran/PLinda source code into
		our target language, Fortran w/ C++ wrappers.
******/
int
Generate(CONTEXT * c, char * file_name)
{
	FILE * plinda;

	if ((plinda=fopen(File_Name,"w"))==NULL)
        {
                fprintf(stderr,"*** ERROR can't open %s file.\n",File_Name);
                exit(1);
        }

/* 1. For each line in source file lex/parse the buffer, echo to <File_Name.f>*/
        while(1)
        {
                lex_key_word(c, plinda, GENERATE);
                if (!CON_next_line(c))
                        break;
                else
                        line_number++;
        }
	return 1;
}

