/********
File:		List.h
Last Revision:	11.15.95 
Purpose:	The list is a list of variable names, types, and the sizes
		corresponding to declarations made in common blocks and 
		subroutines.
*********/

#ifndef LIST_H
#define LIST_H
#include "y.tab.h"

#define COMMA 0
#define DASH  1

typedef struct ListT
{
	int 	variable_type;  /* int, real, character, etc 	 	*/
	char * 	variable_name;	
	int 	variable_size;	/* Number of dimensions if array 	*/
	int 	var_opt_len;	/* Length Spec. for real/character   	*/
	int 	implicit_type;	/* 2 types of implicit =>',' '-' 	*/
				/* These are COMMA, DASH respectively	*/
	char	range_a;	/* Either: (1) Range of any Implicit	*/
	char	range_b; 	/*  decls. or (2) Range of an array 	*/
	
	struct ListT * next;
} List;


List * 	Create_List();
List *  Insert_List(List * l, char * temp, int type, int size, int opt_len);
List *  Insert_List_Implicit(List * l, char r_a, char r_b, int type, int impl);
List * 	Access_List(List * l, char * temp);
void	Print_List(List * l);

#endif
