#include <stdio.h>
#include "Match_Tools.h"
#include "context.h"
#include "plinda_f.h"


/******
Function:	End_of_Line
Purpose:	Returns 0 if not the End_of_Line.  Returns 1 if '\n' or '\0'.
******/
int
End_of_Line(char a)
{
	switch (a)
	{
		case '\n':	
		case '\0':	return 1;
		default:	return 0;
	}
}

/******
Function:	White_Space
Purpose:	Returns 1 if ' ' or '\t'
		Returns 0, otherwise.
******/
int
White_Space(char a)
{
	switch (a)
	{
		case '\t':	return 5;
		case ' ':	return 1;
		default:	return 0;
	}
}

 
/*******
Function:       More_Than_This_Insubstantial_Character
Purpose:        Return 1 if in the string, 'str', there is more there than
                the one insubstantial character passed in.  Return 0, otherwise.
Called From:	Collect_PLinda_TupleSpace() of <Analyze_for_Emittance.c>
*******/
int
More_Than_This_Insubstantial_Character(char str[80], char insubstantial_char)
{
	int test;
        int i = 0;
        while (str[i] != '\0') {
fprintf(stderr,"More_Than_This_Insub:: char => %c",insubstantial_char);
fprintf(stderr,"More_Than_This_Insub:: str[i] => %c\n",str[i]);
fprintf(stderr,"More_Than_This_Insub:: str[i] => %d\n",(int)str[i]);
test =	White_Space(str[i]);
fprintf(stderr,"More_Than_This_Insub:: WhiteSpace test => %d\n",test);
test =	End_of_Line(str[i]);
fprintf(stderr,"More_Than_This_Insub:: End_of_Line=> %d\n",test);

                if (str[i] != insubstantial_char) {
                        if ((White_Space(str[i]) == 0) && (!End_of_Line(str[i]))) {
				fprintf(stderr,"\n\n\t\tMore_Than_This_Insub:: Return 1!!!\n\n");
                                return 1;
                        }
                }
                i++;
        }
        return 0;
}



/******
Function:       Collect_Single_Letter
Purpose:        Collect a single Non-White_Space letter.
Called From:    Collect_Letter_Range
*******/
char
Collect_Single_Letter(CONTEXT * c)
{
        char test;
        do
        {
                test = CON_getc(c);
		if (test == '\n')
		{
			if (Line_Continuation(c))
                		test = CON_getc(c);
		}
        }
        while (White_Space(test) != 0);
        return (test);
}



/******
Function:	Line_Continuation
Purpose:	Returns 1 if the next line has a line continuation symbol.
		When ? => if the 6th column of any line has a character
				that is not a zero or a space.
		(ie.12    +  	i = i + 1
		)
		Also, the present line is echoed out before
		the next line is loaded.
Note:		CON_lookahead_line_cont(c) gets the sixth char. on the
		next line.
Assumption:	This function is only called upon the calling function
		sighting the new-line character.
******/
int
Line_Continuation(CONTEXT * c)
{
	char test_char;
/**
	fprintf(stderr,"Line_Continuation:: current line == %s\n", c->in_buff);
**/
	test_char = CON_lookahead_line_cont(c);
/**
	fprintf(stderr,"Line_Continuation:: next line's char => \n", test_char);
**/
/***
	if (test_char == ' ')
***/
	if (White_Space(test_char) != 0)
	{
		/** No line continuation - return 0 **/
		CON_Reset_lookahead(c);
		return 0;
	}
	else
	{
		Set_lookahead_index(c);
		if (test_char == '0')
		{
			/** No line continuation - return 0 **/
			return 0;
		}
		else
		{
			return 1;
		}
	}
}

