/**************
File:		SymTable.h
Last Revision:	11.3.95
Purpose:	The symbol table is a list of subroutine names.  Inside 
		these subroutines are the lists of variables containing 
		the variable names and type information.
**************/
#ifndef SYMTABLE_H
#define SYMTABLE_H
#include "List.h"

typedef struct SymTableT
{
	char * 	name;
	struct SymTableT * next;
	List * list;
	List * implicit;
} SymTable;


SymTable * 	Create_SymTable();
SymTable * 	Insert_SymTable(SymTable * l, char * name);
SymTable * 	Access_SymTable(SymTable * l, char * name);
SymTable * 	Last_SymTable(SymTable * l);
SymTable * 	Present_SymTable(SymTable * l);
void		Print_SymTable(SymTable * l);

int		Retrieve_from_Implicit(SymTable * l, char); 	
int		Determine_Implicit_Type(char); 	

#endif
