/********
File:		 context.h 
Purpose:	 Buffer to hold each line of the file
		 being read from.
Note(Tom):	 A second buffer has been added to lookahead
		 one line and see if`the next line`is the
		 continuation of the last line.   
		 (ie.		character
			+	*
			+	8
		 The above represents a  declaration of aa character
		 string  of length 8.
		 )
Authors:	 Originally, 	Peter Wyckoff
		 Second,	Tom Brown
Last Altered:	 12/1/95
********/
#ifndef CONTEXT_H
#define CONTEXT_H
			/** Max. Length of any one line in PLinda/Fortran **/
#define BUF_LENGTH 100

typedef struct {
                        int i;            /* current character */
			int line_start;   
			int line_number;  /* Current Line Number in File */
			FILE *fp;
			char in_buff[BUF_LENGTH];

/** Added on for lookahead capabilities for line continuation case **/ 
			char lookahead_buff[BUF_LENGTH];
			int lookahead_eof;
			int lookahead_index;
			} CONTEXT;

extern CONTEXT *CON_create(FILE *f);
extern void     CON_dispose(CONTEXT *c);
extern char	CON_getc(CONTEXT *c);
extern int      CON_next_line(CONTEXT *c);
extern void     CON_backup(CONTEXT *c);
extern void     CON_restore(CONTEXT *c, int backup_spaces);
extern void     CON_reset(CONTEXT *c);
extern void     CON_print(CONTEXT *c);
extern void 	CON_set_line_start(CONTEXT *c);

extern void 	CON_Reset_lookahead(CONTEXT *c);
extern char 	CON_lookahead_line_cont(CONTEXT *c);
extern void 	CON_Set_lookahead_index(CONTEXT *c);
extern void 	Set_lookahead_index(CONTEXT *c);
extern void 	CON_Change_GID_to_INT8(CONTEXT *c);

extern void	CON_Align_to_Char(char, CONTEXT * c);

int CON_Beginning_of_Line(CONTEXT *c);

#endif
