/********
File:		plinda_f.c
Purpose: 	Functions used to output the plinda_f (Fortran + PLinda) 
		file 'plinda.f'.
********/
#include <stdio.h>
#include <stdlib.h>
#include "plinda_f.h"

/*****
Function:	Check_File
Purpose:	Checks if <plinda.f> is open.
*****/
void 
Check_File(FILE * plinda_f)
{
   if (plinda_f == NULL)
   {
      fprintf(stderr,"Compiler Error: File 'plinda.f' closed ; <plinda_f.c>\n");
      exit(1);
   } 
}

void 
Out_PLinda(char * output, FILE * plinda_f)
{
/**
fprintf(stderr,"\tOut_PLinda => %s\n",output);
**/
	Check_File(plinda_f);
	fprintf(plinda_f,output);
}



/********
Function:	 Out_PLinda_Headers(FILE * plinda_f)
Purpose:	In the conversion from Fortran to C, the following functions
		must be declared to return integers at the top of each subroutine
*********/ 
void 
Out_PLinda_Headers(FILE * plinda_f)
{
	fprintf(plinda_f,"            integer ftuple,fargrdp,flint,frint,frstr,flchar\n");
	fprintf(plinda_f,"            integer frfloat,flfloat,frdouble,fldouble\n");
}



void 
Out_PLinda_char(char output, FILE * plinda_f)
{
	char * mess, * head;
	mess = (char *)malloc(sizeof(2 * output));
	head = mess;
	*mess++ = output;
	*mess = '\0';
	Check_File(plinda_f);
	fprintf(plinda_f,head);
}


/******
Function:	Out_PLinda_Int
Purpose:	Write the integer to the file <plinda.f>. 
******/
void 
Out_PLinda_Int(int output, FILE * plinda_f)
{
	Check_File(plinda_f);
	fprintf(plinda_f,"%d",output);
}

