// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _intTupleListCHMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _intTupleListCHMap_h 1

#include "int.TupleList.Map.h"

#ifndef _intTupleListCHNode_h
#define _intTupleListCHNode_h 1

struct intTupleListCHNode
{
  intTupleListCHNode*      tl;
  int                hd;
  TupleList                cont;
                     intTupleListCHNode();
                     intTupleListCHNode(int  h, TupleList& c, intTupleListCHNode* t = 0);
                     ~intTupleListCHNode();
};

inline intTupleListCHNode::intTupleListCHNode() {}

inline intTupleListCHNode::intTupleListCHNode(int  h, TupleList& c, intTupleListCHNode* t)
     : tl(t), hd(h), cont(c) {}

inline intTupleListCHNode::~intTupleListCHNode() {}

typedef intTupleListCHNode* intTupleListCHNodePtr;

#endif


class intTupleListCHMap : public intTupleListMap
{
protected:
  intTupleListCHNode** tab;
  unsigned int   size;

public:
                intTupleListCHMap(TupleList& dflt,unsigned int sz=DEFAULT_INITIAL_CAPACITY);
                intTupleListCHMap(intTupleListCHMap& a);
                ~intTupleListCHMap();

  TupleList&          operator [] (int  key);

  void          del(int  key);

  Pix           first();
  void          next(Pix& i);
  int&          key(Pix i);
  TupleList&          contents(Pix i);

  Pix           seek(int  key);
  int           contains(int  key);

  void          clear(); 
  int           OK();
};


inline intTupleListCHMap::~intTupleListCHMap()
{
  clear();
  delete tab;
}

inline int intTupleListCHMap::contains(int  key)
{
  return seek(key) != 0;
}

inline int& intTupleListCHMap::key(Pix p)
{
  if (p == 0) error("null Pix");
  return ((intTupleListCHNode*)p)->hd;
}

inline TupleList& intTupleListCHMap::contents(Pix p)
{
  if (p == 0) error("null Pix");
  return ((intTupleListCHNode*)p)->cont;
}

#endif
