// This may look like C code, but it is really -*- C++ -*-
//
// File:        plinda.h
// Description: This file declares the client library routines extensions
// Created:      
// Author:      Peter Wyckoff
// Mail:        wyckoff@cs.nyu.edu

#ifndef _PLINDA_PRAGMAS_H_
#define _PLINDA_PRAGMAS_H_

#include <sys/types.h>
#include "plinda_requests.h"
#include "plinda_ids.h"
#include "Tuple.h"

#define pl_pragma_start_trans(loop) PL_pragma_start_trans(loop)
#define pl_pragma_end_trans() PL_pragma_end_trans(__LINE__,__FILE__)
#define pl_change_mode(m,c) PL_change_mode(m,c,__LINE__,__FILE__)
#define pl_change_interactive(i) PL_change_interactive(i,__LINE__,__FILE__)
#define pl_change_interval(i) PL_change_interval(i,__LINE__,__FILE__)
#define pl_stat_begin() 	PL_stat_begin( __LINE__, __FILE__)
#define pl_stat_end(n,i,m,t)      PL_stat_end(n,i,m,t, __LINE__, __FILE__)
#define pl_num_machines() 	PL_num_machines( __LINE__, __FILE__)

void PL_change_mode(Header::FT_ModeType newMode, Tuple *oldContinuation,
		    int line, char *file);
void PL_change_interactive(int i,  int line, char *file);
void PL_change_interval(int i,  int line, char *file);

void PL_pragma_start_trans(int loop);
// this signifies that the same exact transaction will be done loop times
// it will start a timer
// For internal use only!

double PL_pragma_end_trans(int line, char*file);
// this signifies that the xcommit for that transaction is the next statement

 
int PL_num_machines(int, const char*);
void PL_stat_begin(int line,char *file);
void PL_stat_end(int &,int &,int &,int &,int line,char *file);
// numChkpts, checkpointinterval, ft_mode, totalIdleTime of all machines
#endif
